package com.muyu.task.server.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.core.utils.StringUtils;
import com.muyu.common.domian.TaskInfo;
import com.muyu.common.domian.req.TaskInfoListReq;
import com.muyu.common.domian.resp.TaskInfoResp;
import com.muyu.task.server.mapper.TaskInfoMapper;
import com.muyu.task.server.service.TaskInfoService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author Administrator
 */
@Service
public class TaskInfoServiceImpl extends ServiceImpl<TaskInfoMapper, TaskInfo> implements TaskInfoService {

    @Resource
    private TaskInfoMapper taskInfoMapper;

    @Override
    public Page<TaskInfoResp> selectList(TaskInfoListReq req) {
        LambdaQueryWrapper<TaskInfo> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.like(StringUtils.isNotEmpty(req.getName()), TaskInfo::getName, req.getName());
        queryWrapper.eq(req.getWeight()!=null, TaskInfo::getWeight, req.getWeight());
        queryWrapper.eq(StringUtils.isNotEmpty(req.getProcessStatus()), TaskInfo::getProcessStatus, req.getProcessStatus());
        Page<TaskInfo> page = new Page<>(req.getPageNum(), req.getPageSize());
        Page<TaskInfo> taskInfoPage = taskInfoMapper.selectPage(page, queryWrapper);
        long pages = taskInfoPage.getPages();
        long size = taskInfoPage.getSize();
        long current = taskInfoPage.getCurrent();
        List<TaskInfoResp> list = taskInfoPage.getRecords().stream().map(taskInfo -> TaskInfo.build(taskInfo)).toList();
        Page<TaskInfoResp> respPage = new Page<>();
        respPage.setRecords(list);
        respPage.setCurrent(current);
        respPage.setSize(size);
        respPage.setTotal(this.count(queryWrapper));
        respPage.setPages(pages);
        return respPage;
    }
}
