package com.muyu.task.server.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.core.utils.StringUtils;
import com.muyu.common.domian.TaskInput;
import com.muyu.common.domian.req.TaskInputListReq;
import com.muyu.task.server.mapper.TaskInputMapper;
import com.muyu.task.server.service.TaskInputService;
import org.springframework.stereotype.Service;

@Service
public class TaskInputServiceImpl extends ServiceImpl<TaskInputMapper, TaskInput> implements TaskInputService {
    @Override
    public Page<TaskInput> findList(TaskInputListReq req) {
        LambdaQueryWrapper<TaskInput> wrapper = new LambdaQueryWrapper<>();
        wrapper.like(StringUtils.isNotEmpty(req.getNodeName()), TaskInput::getNodeName, req.getNodeName());
        Page<TaskInput> page = new Page<>(req.getPageNum(), req.getPageSize());
        page.setTotal(this.count(wrapper));
        return this.page(page, wrapper);
    }
}
